#ECluster_IncludePath = "..\Include\Include\"
XIncludeFile "..\Include\Include\ECluster_inc.pbi"

UseJPEGImageDecoder()

; Initialisieren
ECluster_Init("..\Include\Windows\ECluster.dll")

Global Log, CRC_Finished, MD5_Finished, Send, CRC_S, MD5_S, LogMutex
LogMutex = CreateMutex() ; Sorgt dafr das der Log immer in der richtigen Reihenfolge bleibt

Procedure AddLog(Text.s, Mutex = 0)
  If Mutex
    LockMutex(Mutex) ; logmutex
  EndIf
  AddGadgetItem(Log, 0, "[" + FormatDate("%hh:%ii:%ss", Date()) + "] " + Text)
  If Mutex
    UnlockMutex(LogMutex)
  EndIf
EndProcedure

; Job CallBack
Procedure LogoLoader(EMaster, Slave, Job, Event, *Mem, MemSize, UserData)
  Protected Img
  If Event = #Event_Job_Finished
    Img = CatchImage(#PB_Any, *Mem)
    ECluster_FreeMemory(*Mem)
    SetGadgetState(UserData, ImageID(Img))
  ElseIf Event = #Event_Job_Denied
    MessageRequester("", "Job verweigert")
  EndIf
EndProcedure

; Job CallBack
Procedure MD5_CB(EMaster, Slave, Job, Event, *Mem, MemSize, UserData)
  Select Event
    Case #Event_Job_Received
      AddLog("MD5 Received", UserData)
    Case #Event_Job_Unknown
      AddLog("MD5 Unknown", UserData)
    Case #Event_Job_inProgress
      AddLog("MD5 in Progress", UserData)
    Case #Event_Job_Finished
      AddLog("MD5 Finished ", UserDAta)
      ; Ergebnisse holen
      SetGadgetText(MD5_S, PeekS(*Mem))
      ECluster_FreeMemory(*Mem)
      MD5_Finished = #True
      If (CRC_Finished And MD5_Finished)
        DisableGadget(Send, 0)
      EndIf
    Case #Event_Job_Limit
      MessageRequester("", "JobLimit berschritten")
  EndSelect
EndProcedure

; Job CallBack
Procedure CRC_CB(EMaster, Slave, Job, Event, *Mem, MemSize, UserData)
  Select Event
    Case #Event_Job_Received
      AddLog("CRC Received", UserData)
    Case #Event_Job_Unknown
      AddLog("CRC Unknown", UserData)
    Case #Event_Job_inProgress
      AddLog("CRC in Progress", UserData)
    Case #Event_Job_Finished
      AddLog("CRC Finished", UserData)
      ; Ergebnisse holen
      SetGadgetText(CRC_S, Str(PeekL(*Mem)))
      ECluster_FreeMemory(*Mem)
      CRC_Finished = #True
      If (CRC_Finished And MD5_Finished)
        DisableGadget(Send, 0)
      EndIf
    Case #Event_Job_Limit
      MessageRequester("", "JobLimit berschritten")
  EndSelect
EndProcedure

; Event Handler
Procedure EventHandler(EMaster, Slave, Job, Event, *Mem, MemSize, *_End.Integer)
  Select Event
    Case #Event_Slave_Paused
      AddLog("Slave Paused")
      
    Case #Event_Slave_Resumed
      AddLog("Slave Resumed")
      
    Case #Event_Slave_Kick
      MessageRequester("Slave Kick", "Wir waren bse ^^")
      *_End\i = #True
      
    Case #Event_Slave_Quit
      MessageRequester("Slave Quit", "Slave Quit")
      *_End\i = #True
      
    Case #Event_Slave_BufferUnderrun
      MessageRequester("Error", "Slave Buffer Underrun")
      
    Case #Event_Master_BufferUnderrun
      MessageRequester("Error", "Master Buffer Underrun")
      
  EndSelect
EndProcedure

Define EndFlag

M1 = ECluster_Master_Init(8)
If M1
  ECluster_Master_SetReceiveBlockSize(M1, 1000)
  ECluster_Master_SetCallback(M1, @EventHandler(), @EndFlag)
  ; Slave hinzufgen
  Slave = ECluster_Master_AddSlave(M1, "localhost", 444)
  If Slave
    ; Fenster aufbauen
    Main = OpenWindow(#PB_Any, 0, 0, 300, 340, "Master Demo", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
    TextGadget(#PB_Any, 5, 8, 30, 20, "Text: ")
    Text = StringGadget(#PB_Any, 35, 5, 185, 20, "Demotext")
    Send = ButtonGadget(#PB_Any, 225, 5, 70, 20, "Prfen")
    TextGadget(#PB_Any, 5, 38, 70, 20, "CRC Lokal: ")
    CRC_L = TextGadget(#PB_Any, 80, 38, 215, 20, "")
    TextGadget(#PB_Any, 5, 58, 70, 20, "CRC Server: ")
    CRC_S = TextGadget(#PB_Any, 80, 58, 215, 20, "")
    TextGadget(#PB_Any, 5, 78, 70, 20, "MD5 Lokal: ")
    MD5_L = TextGadget(#PB_Any, 80, 78, 215, 20, "")
    TextGadget(#PB_Any, 5, 98, 70, 20, "MD5 Server: ")
    MD5_S = TextGadget(#PB_Any, 80, 98, 215, 20, "")
    
    Log = EditorGadget(#PB_Any, 5, 130, 290, 65, #PB_Editor_ReadOnly)
    Logo = ImageGadget(#PB_Any, 35, 200, 290, 95, 0)
    
    ; Logo holen
    Job = ECluster_Master_DoJob(M1, "GetLogo", Slave, 0, @LogoLoader(), Logo)
    
    Repeat
      Event = WaitWindowEvent(1)
      
      ; Window events normal abarbeiten
      Select Event
        Case #PB_Event_Gadget
          Select EventGadget()
            Case Send
              DisableGadget(Send, 1)
              CRC_Finished = #False
              MD5_Finished = #False
              RefText.s = GetGadgetText(Text)
              
              For i = 1 To 100
                Para = ECluster_Parameter_New()
                ECluster_Parameter_AddString(Para, RefText)
                CRC_Job = ECluster_Master_DoJob(M1, "CRC_Text", Slave, Para, @CRC_CB(), LogMutex)
                If CRC_Job = -1
                  MessageRequester("Fehler", "Fehler beim senden")
                EndIf
                
                Para = ECluster_Parameter_New()
                ECluster_Parameter_AddString(Para, RefText)
                MD5_Job = ECluster_Master_DoJob(M1, "MD5_Text", Slave, Para, @MD5_CB(), LogMutex)
                If MD5_Job = -1
                  MessageRequester("Fehler", "Fehler beim senden")
                EndIf
              Next
              SetGadgetText(CRC_L, Str(CRC32Fingerprint(@RefText, Len(RefText))))
              SetGadgetText(MD5_L, MD5Fingerprint(@RefText, Len(RefText)))
              
              SetGadgetText(CRC_S, "")
              SetGadgetText(MD5_S, "")
              
          EndSelect
      EndSelect
    Until Event = #PB_Event_CloseWindow Or EndFlag
    
  EndIf
  ECluster_Master_DeInit(M1)
EndIf
; IDE Options = PureBasic 4.31 (Windows - x86)
; CursorPosition = 107
; FirstLine = 105
; Folding = -
; EnableThread
; EnableXP
; Executable = MD5_CRC_Master_Trigger.exe
; DisableDebugger