

#ECluster_IncludePath = "..\Include\Include\"
XIncludeFile "..\Include\Include\ECluster_inc.pbi"

ECluster_Init("..\Include\Windows\ECluster.dll")

Macro CheckCache()
  Debug "----------"
  Debug "Block1: " + Str(ECluster_Cache_isCached(C1, "Block1"))
  Debug "Block2: " + Str(ECluster_Cache_isCached(C1, "Block2"))
  Debug "Block3: " + Str(ECluster_Cache_isCached(C1, "Block3"))
  Debug "Block4: " + Str(ECluster_Cache_isCached(C1, "Block4"))
  Debug "----------"
EndMacro

; Speicherblcke anlegen:
*Mem1 = AllocateMemory(200)
*Mem2 = AllocateMemory(300)
*Mem3 = AllocateMemory(100)
*Mem4 = AllocateMemory(500)

; Neuen Cache anlegen mit 1000 Bytes Limit
C1 = ECluster_Cache_New(1000)

; Erst mal 2 Blcke Cachen:
ECluster_Cache_AddEntry(C1, "Block1", *Mem1, 200)
ECluster_Cache_AddEntry(C1, "Block2", *Mem2, 300)

Debug "Block1 & Block2 wurden gesetzt und mssten nun erkannt werden"
CheckCache()

; Nun die anderen 2 Blcke
ECluster_Cache_AddEntry(C1, "Block3", *Mem3, 100, 1) ; Maximal eine Sekunde Lebensdauer

ECluster_Cache_isCached(C1, "Block3")

ECluster_Cache_AddEntry(C1, "Block4", *Mem4, 500)

Debug "Block3 & Block4 wurden gesetzt. Die Maximalgre wurde berschritten, daher wurde 1 gelscht da alle Blcke dieselbe Zugriffszeit/Zugriffe hatten und er am ltesten war"
CheckCache()

Delay(1000)

Debug "Nun ist auch Block3 aus da er die Altersgerenze berschritten hat"
CheckCache()

; Kommentar entfernen zum Testen:
; Block4 hat dann mehr Zugriffe als Block2 und wird daher fr schnelleren Zugriff nach vorne gerreiht
ECluster_Cache_isCached(C1, "Block4")
ECluster_Cache_isCached(C1, "Block4")
ECluster_Cache_Optimize(C1)

; Nun Speichern wir den Cache temporr als Datei:
ECluster_Cache_SaveToFile(C1, GetTemporaryDirectory() + "Cache.tmp")

; Alles freigeben
ECluster_Cache_Free(C1)
FreeMemory(*Mem1)
FreeMemory(*Mem2)
FreeMemory(*Mem3)
FreeMemory(*Mem4)

; Neuen Cache:

C2 = ECluster_Cache_New()

; Cache aus Datei laden:
ECluster_Cache_LoadFromFile(C2, GetTemporaryDirectory() + "Cache.tmp")
; Alle Entrys anzeigen:
ECluster_Cache_Examine(C2)
While ECluster_Cache_NextEntry(C2)
  Debug "Entry: " + ECluster_Cache_GetName(C2) + " Gre: " + Str(ECluster_Cache_GetMemSize(C2))
Wend



; IDE Options = PureBasic 4.31 (Windows - x86)
; CursorPosition = 6
; Folding = -
; EnableXP