Structure EChar
  c.c[0]
EndStructure

Structure PWGen_Data
  E.c[257]
  rCS.s
  First.c
  Last.c
  SPW.s
  cLen.i
EndStructure

Procedure PWGen_Init(CharSet.s, PW.s = "")
  Protected *CS.PWGen_Data = AllocateMemory(SizeOf(PWGen_Data))
  Protected i, *CS_Raw.EChar = @CharSet, CS_Len = Len(CharSet)-1
  With *CS
    \SPW = PW
    \rCS = CharSet
    \First = *CS_Raw\c[0]
    \Last = *CS_Raw\c[CS_Len]
    \cLen = 1
    For i = 0 To CS_Len-1
      \E[*CS_Raw\c[i]] = *CS_Raw\c[i + 1]
    Next
    
    ProcedureReturn *CS
  EndWith
EndProcedure

Procedure PWGen_DeInit(*CS.PWGen_Data)
  Protected String.String, String2.String
  PokeL(@String, @*CS\SPW)
  PokeL(@String2, @*CS\rCS)
  FreeMemory(*CS)
EndProcedure

Procedure PWGen_Set(*CS.PWGen_Data, PW.s)
  *CS\SPW = PW
  *CS\cLen = Len(PW)
EndProcedure

Procedure PWGen_Next(*CS.PWGen_Data)
  Protected *PW.Character = @*CS\SPW, DoChange = #True
  
  While *PW\c
    If *PW\c = *CS\Last
      *PW\c = *CS\First
    Else
      *PW\c = *CS\E[*PW\c]
      DoChange = #False
      Break
    EndIf
    *PW + SizeOf(Character)
  Wend
  
  If DoChange
    *CS\cLen + 1
    *CS\SPW = RSet("", *CS\cLen, Chr(*CS\First))
  EndIf
EndProcedure

Procedure.s PWGen_Part(*CS.PWGen_Data, Len, Parts, Sep.s = ";")
  Protected PLen = Len(*CS\rCS)/Parts, RtVar.s
  RtVar = RSet("", Len, Chr(*CS\First)) + Sep
  For i = 1 To Parts-1
    RtVar + RSet("", Len, Mid(*CS\rCS, i*PLen, 1)) + Sep
  Next
  RtVar + RSet("", Len, Chr(*CS\Last))
  ProcedureReturn RtVar
EndProcedure

Procedure.s MD5_Find(*CS.PWGen_Data, StartPW.s, StopPW.s, MD5.s)
  Protected Result.s, *cPwMem = @StopPW
  PWGen_Set(*CS, StartPW)
  Repeat
    PWGen_Next(*CS)
    If MD5Fingerprint(@*CS\SPW, *CS\cLen) = MD5
      Result = *CS\SPW
      Break
    EndIf
  Until Not CompareMemoryString(@*CS\SPW, *cPwMem, *CS\cLen)
  ProcedureReturn Result
EndProcedure

Procedure.s MD5_Find_Simple(Charset.s, StartPW.s, StopPW.s, MD5.s)
  ProcedureReturn MD5_Find(PWGen_Init(Charset), StartPW, StopPW, MD5)
EndProcedure
; IDE Options = PureBasic 4.30 (Windows - x86)
; CursorPosition = 87
; Folding = --
; EnableAsm
; EnableXP