; ------------------------------------------------------------------------------------
; Sonstige Routinen
;
; ------------------------------------------------------------------------------------

; ------------------------------------------------------------------------------------
;- Strukturen
; ------------------------------------------------------------------------------------

Structure ECluster_Mem
  *Mem
  MemSize.i
EndStructure

; ------------------------------------------------------------------------------------
;- Parameter Routinen
;
; Routinen um bergabeparameter schreiben und zu lesen
; ------------------------------------------------------------------------------------

; ------------------------------------------------------------------------------------
; Neuen ParameterStack anlegen
;
; Rckgabe:
; Parameter - Handle
; ------------------------------------------------------------------------------------

Prototype _ECluster_Parameter_New()

; ------------------------------------------------------------------------------------
; Parameter auf Stack zhlen
;
; ParameterStack: Parameter - Handle
; ------------------------------------------------------------------------------------

Prototype _ECluster_Parameter_Count(ParameterStack)

; ------------------------------------------------------------------------------------
; Speicher zum ParameterStack hinzufgen
;
; ParameterStack: Parameter - Handle
; *Mem : Speicheraddresse
; MemSize: Speichergre
;
; Rckgabe: #Null
; ------------------------------------------------------------------------------------

Prototype _ECluster_Parameter_AddMem(ParameterStack, *Mem, MemSize)

; ------------------------------------------------------------------------------------
; Long zum ParameterStack hinzufgen
;
; ParameterStack: Parameter - Handle
;
; Rckgabe: #Null
; ------------------------------------------------------------------------------------

Prototype _ECluster_Parameter_AddLong(ParameterStack, Long.l)

; ------------------------------------------------------------------------------------
; Integer zum ParameterStack hinzufgen
;
; ParameterStack: Parameter - Handle
;
; Rckgabe: #Null
; ------------------------------------------------------------------------------------

Prototype _ECluster_Parameter_AddInteger(ParameterStack, Integer.i)

; ------------------------------------------------------------------------------------
; Float zum ParameterStack hinzufgen
;
; ParameterStack: Parameter - Handle
;
; Rckgabe: #Null
; ------------------------------------------------------------------------------------

Prototype _ECluster_Parameter_AddFloat(ParameterStack, Float.f)

; ------------------------------------------------------------------------------------
; Double zum ParameterStack hinzufgen
;
; ParameterStack: Parameter - Handle
;
; Rckgabe: #Null
; ------------------------------------------------------------------------------------

Prototype _ECluster_Parameter_AddDouble(ParameterStack, Double.d)

; ------------------------------------------------------------------------------------
; Quad zum ParameterStack hinzufgen
;
; ParameterStack: Parameter - Handle
;
; Rckgabe: #Null
; ------------------------------------------------------------------------------------

Prototype _ECluster_Parameter_AddQuad(ParameterStack, Quad.q)

; ------------------------------------------------------------------------------------
; String zum ParameterStack hinzufgen
;
; ParameterStack: Parameter - Handle
;
; Rckgabe: #Null
; ------------------------------------------------------------------------------------

Prototype _ECluster_Parameter_AddString(ParameterStack, String.s)

; ------------------------------------------------------------------------------------
; Memory vom ParameterStack holen
;
; ParameterStack: Parameter - Handle
;
; Rckgabe: Pointer auf ECluster_Mem- Structure
; ------------------------------------------------------------------------------------

Prototype _ECluster_Parameter_GetMem(ParameterStack)

; ------------------------------------------------------------------------------------
; Long vom ParameterStack holen
;
; ParameterStack: Parameter - Handle
;
; Rckgabe: Parameterwert
; ------------------------------------------------------------------------------------

Prototype.l _ECluster_Parameter_GetLong(ParameterStack)

; ------------------------------------------------------------------------------------
; Integer vom ParameterStack holen
;
; ParameterStack: Parameter - Handle
;
; Rckgabe: Parameterwert
; ------------------------------------------------------------------------------------

Prototype.i _ECluster_Parameter_GetInteger(ParameterStack)

; ------------------------------------------------------------------------------------
; Float vom ParameterStack holen
;
; ParameterStack: Parameter - Handle
;
; Rckgabe: Parameterwert
; ------------------------------------------------------------------------------------

Prototype.f _ECluster_Parameter_GetFloat(ParameterStack)

; ------------------------------------------------------------------------------------
; Double vom ParameterStack holen
;
; ParameterStack: Parameter - Handle
;
; Rckgabe: Parameterwert
; ------------------------------------------------------------------------------------

Prototype.d _ECluster_Parameter_GetDouble(ParameterStack)

; ------------------------------------------------------------------------------------
; Quad vom ParameterStack holen
;
; ParameterStack: Parameter - Handle
;
; Rckgabe: Parameterwert
; ------------------------------------------------------------------------------------

Prototype.q _ECluster_Parameter_GetQuad(ParameterStack)

; ------------------------------------------------------------------------------------
; String vom ParameterStack holen
;
; ParameterStack: Parameter - Handle
;
; Rckgabe: Parameterwert
; ------------------------------------------------------------------------------------

Prototype _ECluster_Parameter_GetString(ParameterStack)

; ------------------------------------------------------------------------------------
;- Rckgabe Routinen
;
; Routinen zum zurckgeben von Daten aus den Servive - Proceuduren
; ------------------------------------------------------------------------------------

; ------------------------------------------------------------------------------------
; Speicher aus ECluster_Job() - Procedure zurckgeben
;
; *Mem: Speicheraddresse
; MemSize: Speichergre
; ------------------------------------------------------------------------------------

Prototype _ECluster_Return_Memory(*Mem, MemSize)

; ------------------------------------------------------------------------------------
; Long aus ECluster_Job() - Procedure zurckgeben
; ------------------------------------------------------------------------------------

Prototype _ECluster_Return_Long(Long.l)

; ------------------------------------------------------------------------------------
; Integer aus ECluster_Job() - Procedure zurckgeben
; ------------------------------------------------------------------------------------

Prototype _ECluster_Return_Integer(Integer.i)

; ------------------------------------------------------------------------------------
; Float aus ECluster_Job() - Procedure zurckgeben
; ------------------------------------------------------------------------------------

Prototype _ECluster_Return_Float(Float.f)

; ------------------------------------------------------------------------------------
; Double aus ECluster_Job() - Procedure zurckgeben
; ------------------------------------------------------------------------------------

Prototype _ECluster_Return_Double(Double.d)

; ------------------------------------------------------------------------------------
; Quad aus ECluster_Job() - Procedure zurckgeben
; ------------------------------------------------------------------------------------

Prototype _ECluster_Return_Quad(Quad.q)

; ------------------------------------------------------------------------------------
; String aus ECluster_Job() - Procedure zurckgeben
; ------------------------------------------------------------------------------------

Prototype _ECluster_Return_String(String.s)

; ------------------------------------------------------------------------------------

; ------------------------------------------------------------------------------------
;- Memory - Dummy Funktionen
; da sonst die Speicherverwaltung von Windows beleidigt ist
; ------------------------------------------------------------------------------------

Prototype _ECluster_AllocateMemory(MemSize)
Prototype _ECluster_FreeMemory(Mem)

; ------------------------------------------------------------------------------------
;- Versionsabfrage
; ------------------------------------------------------------------------------------

; ------------------------------------------------------------------------------------
; Gibt die aktuelle ECluster - Version als String zurck
;
; Rckgabe: ECluster - Version
; ------------------------------------------------------------------------------------

Prototype _ECluster_GetVersion()

; ------------------------------------------------------------------------------------
;- Funktionen Deklarieren
; ------------------------------------------------------------------------------------

Global ECluster_Parameter_New._ECluster_Parameter_New
Global ECluster_Parameter_AddMem._ECluster_Parameter_AddMem
Global ECluster_Parameter_AddLong._ECluster_Parameter_AddLong
Global ECluster_Parameter_AddInteger._ECluster_Parameter_AddInteger
Global ECluster_Parameter_AddFloat._ECluster_Parameter_AddFloat
Global ECluster_Parameter_AddDouble._ECluster_Parameter_AddDouble
Global ECluster_Parameter_AddQuad._ECluster_Parameter_AddQuad
Global ECluster_Parameter_AddString._ECluster_Parameter_AddString
Global ECluster_Parameter_GetMem._ECluster_Parameter_GetMem
Global ECluster_Parameter_GetLong._ECluster_Parameter_GetLong
Global ECluster_Parameter_GetInteger._ECluster_Parameter_GetInteger
Global ECluster_Parameter_GetFloat._ECluster_Parameter_GetFloat
Global ECluster_Parameter_GetDouble._ECluster_Parameter_GetDouble
Global ECluster_Parameter_GetQuad._ECluster_Parameter_GetQuad
Global _ECluster_Parameter_GetString._ECluster_Parameter_GetString

Global ECluster_Return_Memory._ECluster_Return_Memory
Global ECluster_Return_Long._ECluster_Return_Long
Global ECluster_Return_Integer._ECluster_Return_Integer
Global ECluster_Return_Float._ECluster_Return_Float
Global ECluster_Return_Double._ECluster_Return_Double
Global ECluster_Return_Quad._ECluster_Return_Quad
Global ECluster_Return_String._ECluster_Return_String

Global ECluster_AllocateMemory._ECluster_AllocateMemory
Global ECluster_FreeMemory._ECluster_FreeMemory

Global _ECluster_GetVersion._ECluster_GetVersion

Procedure.s ECluster_Parameter_GetString(ParameterStack)
  Protected String$, *StringMem = _ECluster_Parameter_GetString(ParameterStack)
  If *StringMem
    String$ = PeekS(*StringMem)
    ECluster_FreeMemory(*StringMem)
    ProcedureReturn String$
  EndIf
EndProcedure

Macro ECluster_GetVersion()
  PeekS(_ECluster_GetVersion())
EndMacro

; IDE Options = PureBasic 4.31 (Windows - x86)
; CursorPosition = 294
; FirstLine = 254
; Folding = -
; EnableXP